



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>stdout( 标准输出流）和 stderr( 标准输入流)  重定向问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">stdout( 标准输出流）和 stderr( 标准输入流)  重定向问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 02:13:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　我想把提示信息和错误信息列表都写入到同一个文件里，</p>
<div>
<pre class="prettyprint linenums"> /*<br />
 ** 设置流, 使输出与错误流都指向指定的文件<br />
 */<br />
 if( (output1 = freopen( PATH, "a", stdout ) ) == NULL )<br />
     exit( EXIT_FAILURE );

 if( (output2 = freopen( PATH, "a", stderr ) ) == NULL )<br />
     exit( EXIT_FAILURE );</pre>
</div>
<p>　&nbsp; 开始， 我这么写</p>
<div>
<pre class="prettyprint linenums">fputs( "错误列表：\n", output1 );<br />
for( i = ; i &lt;= ; i ++ ){<br />
       errno = i;<br />
       perror( "ERROR" );<br />
}</pre>
</div>
<p>结果， 文件中的内容是 错误信息列表在前面， 提示信息在结尾处。</p>
<p>我百度了下， 发现stdout流的缓冲方式是完全缓冲，stderr是不缓冲， 完全缓冲是指等缓冲区满了后写入， 所以我用setvbuf改变了stdout的缓冲方式（ 还要声明一个足够大的数组buffer)， 改成不缓冲， 即在这段代码前添加一句</p>
<div>
<pre class="prettyprint linenums">setvbuf( output1, buffer, _IONBF, BUFSIZ );</pre>
</div>
<p>这样，问题就解决了。</p>
<p>还有一种办法， 就是在fputs后加一句&nbsp;&nbsp; fflush( output1 );&nbsp; 意思是立即写入缓冲区的内容。</p>
<p>最后， 贴出结果， 嘻嘻</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/551731/201512/551731-20151201113239515-1244322793.bmp" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390ko3qd.html">ABP源码分析二十二：Navigation</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gp0jl9.html">Qt 之 入门例程 &lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j2ngl8.html">A - 迷宫问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93knk0q.html">Sigmaplot激活码获取地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmrym8.html">Emgu学习之（四）&mdash;&mdash;图像阈值</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvp06zq.html">提供给Android和iOS开发人员的UWP移植向导</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rep6dq.html">nginx 的源码安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xw41n9.html">iBeacons 资源汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj7l68.html">【转】ASP&period;NET 高效分页存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p1nx9.html">How to Validate XML using Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meemm0q.html">Cocos2d-x  Layout简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zovoldq.html">如何直观的解释back propagation算法？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey5d6j9.html">tableView的编辑</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrz5e9.html">c&num; Lambda操作类封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1p4x49.html">JSP基础知识➣语法整理（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w1m3nq.html">发现Boost官方文档的一处错误&lpar;numpy的ndarray&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj3jm39.html">c&plus;&plus;的动态绑定和静态绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kwojwq.html">既使用maven编译，又使用lib下的Jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzo10q.html">eclipse help说明链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv60ggq.html">jsoncpp cmake</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49g6xjzq.html">loadrunner解决在项目中的难点解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn6l339.html">JavaScript设计模式&mdash;&mdash;单体模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqld2dx9.html">jQuery-插件，优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m66y29.html">ZJOI2016 Round 1 之前</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq451o59.html">HDU4080 Stammering Aliens（二分 &plus; 后缀数组）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8op03eq.html">NUC&lowbar;HomeWork1 -- POJ2067&lpar;最短路&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g6wy7q.html">BZOJ3172&lbrack;Tjoi2013&rsqb;单词 题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd17g0q.html">ACM&colon;   HDU 1285 确定比赛名次 - 拓扑排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqld6dk9.html">&lpar;&lpar;ParameterizedType&rpar; getClass&lpar;&rpar;&period;getGenericSuperclass&lpar;&rpar;&rpar;&period;getActualTypeArguments&lpar;&rpar;&lbrack;0&rsqb;的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2epe3q.html">Jquery实现下拉联动表单</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
